# coding: utf-8

"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from bimdata_api_client.configuration import Configuration


class ModelProperty(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'definition': 'PropertyDefinition',
        'value': 'object',
        'property_set_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'definition': 'definition',
        'value': 'value',
        'property_set_id': 'property_set_id'
    }

    def __init__(self, id=None, definition=None, value=None, property_set_id=None, local_vars_configuration=None):  # noqa: E501
        """ModelProperty - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._definition = None
        self._value = None
        self._property_set_id = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.definition = definition
        self.value = value
        if property_set_id is not None:
            self.property_set_id = property_set_id

    @property
    def id(self):
        """Gets the id of this ModelProperty.  # noqa: E501


        :return: The id of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ModelProperty.


        :param id: The id of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def definition(self):
        """Gets the definition of this ModelProperty.  # noqa: E501


        :return: The definition of this ModelProperty.  # noqa: E501
        :rtype: PropertyDefinition
        """
        return self._definition

    @definition.setter
    def definition(self, definition):
        """Sets the definition of this ModelProperty.


        :param definition: The definition of this ModelProperty.  # noqa: E501
        :type: PropertyDefinition
        """
        if self.local_vars_configuration.client_side_validation and definition is None:  # noqa: E501
            raise ValueError("Invalid value for `definition`, must not be `None`")  # noqa: E501

        self._definition = definition

    @property
    def value(self):
        """Gets the value of this ModelProperty.  # noqa: E501


        :return: The value of this ModelProperty.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this ModelProperty.


        :param value: The value of this ModelProperty.  # noqa: E501
        :type: object
        """

        self._value = value

    @property
    def property_set_id(self):
        """Gets the property_set_id of this ModelProperty.  # noqa: E501

        This field is useful when you update a property and the  API is rebuilding a new property set to avoid an update on many elements. It gives you the new pset id  # noqa: E501

        :return: The property_set_id of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._property_set_id

    @property_set_id.setter
    def property_set_id(self, property_set_id):
        """Sets the property_set_id of this ModelProperty.

        This field is useful when you update a property and the  API is rebuilding a new property set to avoid an update on many elements. It gives you the new pset id  # noqa: E501

        :param property_set_id: The property_set_id of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._property_set_id = property_set_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ModelProperty):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ModelProperty):
            return True

        return self.to_dict() != other.to_dict()
