# coding: utf-8

"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from bimdata_api_client.configuration import Configuration


class PerspectiveCamera(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'field_of_view': 'float',
        'camera_direction': 'Direction',
        'camera_up_vector': 'Direction',
        'camera_view_point': 'Point',
        'bimdata_camera_direction': 'Direction'
    }

    attribute_map = {
        'field_of_view': 'field_of_view',
        'camera_direction': 'camera_direction',
        'camera_up_vector': 'camera_up_vector',
        'camera_view_point': 'camera_view_point',
        'bimdata_camera_direction': 'bimdata_camera_direction'
    }

    def __init__(self, field_of_view=None, camera_direction=None, camera_up_vector=None, camera_view_point=None, bimdata_camera_direction=None, local_vars_configuration=None):  # noqa: E501
        """PerspectiveCamera - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._field_of_view = None
        self._camera_direction = None
        self._camera_up_vector = None
        self._camera_view_point = None
        self._bimdata_camera_direction = None
        self.discriminator = None

        self.field_of_view = field_of_view
        self.camera_direction = camera_direction
        self.camera_up_vector = camera_up_vector
        self.camera_view_point = camera_view_point
        if bimdata_camera_direction is not None:
            self.bimdata_camera_direction = bimdata_camera_direction

    @property
    def field_of_view(self):
        """Gets the field_of_view of this PerspectiveCamera.  # noqa: E501


        :return: The field_of_view of this PerspectiveCamera.  # noqa: E501
        :rtype: float
        """
        return self._field_of_view

    @field_of_view.setter
    def field_of_view(self, field_of_view):
        """Sets the field_of_view of this PerspectiveCamera.


        :param field_of_view: The field_of_view of this PerspectiveCamera.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and field_of_view is None:  # noqa: E501
            raise ValueError("Invalid value for `field_of_view`, must not be `None`")  # noqa: E501

        self._field_of_view = field_of_view

    @property
    def camera_direction(self):
        """Gets the camera_direction of this PerspectiveCamera.  # noqa: E501


        :return: The camera_direction of this PerspectiveCamera.  # noqa: E501
        :rtype: Direction
        """
        return self._camera_direction

    @camera_direction.setter
    def camera_direction(self, camera_direction):
        """Sets the camera_direction of this PerspectiveCamera.


        :param camera_direction: The camera_direction of this PerspectiveCamera.  # noqa: E501
        :type: Direction
        """
        if self.local_vars_configuration.client_side_validation and camera_direction is None:  # noqa: E501
            raise ValueError("Invalid value for `camera_direction`, must not be `None`")  # noqa: E501

        self._camera_direction = camera_direction

    @property
    def camera_up_vector(self):
        """Gets the camera_up_vector of this PerspectiveCamera.  # noqa: E501


        :return: The camera_up_vector of this PerspectiveCamera.  # noqa: E501
        :rtype: Direction
        """
        return self._camera_up_vector

    @camera_up_vector.setter
    def camera_up_vector(self, camera_up_vector):
        """Sets the camera_up_vector of this PerspectiveCamera.


        :param camera_up_vector: The camera_up_vector of this PerspectiveCamera.  # noqa: E501
        :type: Direction
        """
        if self.local_vars_configuration.client_side_validation and camera_up_vector is None:  # noqa: E501
            raise ValueError("Invalid value for `camera_up_vector`, must not be `None`")  # noqa: E501

        self._camera_up_vector = camera_up_vector

    @property
    def camera_view_point(self):
        """Gets the camera_view_point of this PerspectiveCamera.  # noqa: E501


        :return: The camera_view_point of this PerspectiveCamera.  # noqa: E501
        :rtype: Point
        """
        return self._camera_view_point

    @camera_view_point.setter
    def camera_view_point(self, camera_view_point):
        """Sets the camera_view_point of this PerspectiveCamera.


        :param camera_view_point: The camera_view_point of this PerspectiveCamera.  # noqa: E501
        :type: Point
        """
        if self.local_vars_configuration.client_side_validation and camera_view_point is None:  # noqa: E501
            raise ValueError("Invalid value for `camera_view_point`, must not be `None`")  # noqa: E501

        self._camera_view_point = camera_view_point

    @property
    def bimdata_camera_direction(self):
        """Gets the bimdata_camera_direction of this PerspectiveCamera.  # noqa: E501


        :return: The bimdata_camera_direction of this PerspectiveCamera.  # noqa: E501
        :rtype: Direction
        """
        return self._bimdata_camera_direction

    @bimdata_camera_direction.setter
    def bimdata_camera_direction(self, bimdata_camera_direction):
        """Sets the bimdata_camera_direction of this PerspectiveCamera.


        :param bimdata_camera_direction: The bimdata_camera_direction of this PerspectiveCamera.  # noqa: E501
        :type: Direction
        """

        self._bimdata_camera_direction = bimdata_camera_direction

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PerspectiveCamera):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PerspectiveCamera):
            return True

        return self.to_dict() != other.to_dict()
