# coding: utf-8

"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from bimdata_api_client.configuration import Configuration


class ProcessorHandler(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'worker': 'str',
        'status': 'str',
        'detail_message': 'str'
    }

    attribute_map = {
        'id': 'id',
        'worker': 'worker',
        'status': 'status',
        'detail_message': 'detail_message'
    }

    def __init__(self, id=None, worker=None, status=None, detail_message=None, local_vars_configuration=None):  # noqa: E501
        """ProcessorHandler - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._worker = None
        self._status = None
        self._detail_message = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if worker is not None:
            self.worker = worker
        if status is not None:
            self.status = status
        self.detail_message = detail_message

    @property
    def id(self):
        """Gets the id of this ProcessorHandler.  # noqa: E501


        :return: The id of this ProcessorHandler.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ProcessorHandler.


        :param id: The id of this ProcessorHandler.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def worker(self):
        """Gets the worker of this ProcessorHandler.  # noqa: E501


        :return: The worker of this ProcessorHandler.  # noqa: E501
        :rtype: str
        """
        return self._worker

    @worker.setter
    def worker(self, worker):
        """Sets the worker of this ProcessorHandler.


        :param worker: The worker of this ProcessorHandler.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                worker is not None and len(worker) < 1):
            raise ValueError("Invalid value for `worker`, length must be greater than or equal to `1`")  # noqa: E501

        self._worker = worker

    @property
    def status(self):
        """Gets the status of this ProcessorHandler.  # noqa: E501


        :return: The status of this ProcessorHandler.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ProcessorHandler.


        :param status: The status of this ProcessorHandler.  # noqa: E501
        :type: str
        """
        allowed_values = ["C", "D", "P", "W", "I", "E", "X"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def detail_message(self):
        """Gets the detail_message of this ProcessorHandler.  # noqa: E501


        :return: The detail_message of this ProcessorHandler.  # noqa: E501
        :rtype: str
        """
        return self._detail_message

    @detail_message.setter
    def detail_message(self, detail_message):
        """Sets the detail_message of this ProcessorHandler.


        :param detail_message: The detail_message of this ProcessorHandler.  # noqa: E501
        :type: str
        """

        self._detail_message = detail_message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessorHandler):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProcessorHandler):
            return True

        return self.to_dict() != other.to_dict()
